#!/usr/bin/perl -w

use Cwd;
use Getopt::Long;
use List::Util qw(max min);

my @p00 = (0,0,0);
my @p01 = (0,0,0);
my @p10 = (0,0,0);
my @p11 = (0,0,0);
my @p20 = (0,0,0);
my @p21 = (0,0,0);

my @seg1 = ([@p00],[@p01]);
my @seg2 = ([@p10],[@p11]);
my @seg3 = ([@p20],[@p21]);
my @segs = ([@seg1], [@seg2], [@seg3]);
my $help = 0;
my $id = 0;

$Getopt::Long::ignorecase = 0;
GetOptions("help" => \$help,
	   '<>' => \&process) or die "Bad command line option!";
usage() if $help;

sub usage {
    printf "lts options";
    printf "
\t--help\t\t\tprint this help message
";
    exit(0);
}

sub process {
    $data = "@_\n";
    @info = split(/[\(\) ,\n\t\r]+/, $data);    
    #print "@info\n";
    shift(@info);
    #print "$#info\n";
#     print "info[0] = $info[0]\n";
#     print "info[1] = $info[1]\n";
#     print "info[2] = $info[2]\n";
#     print "info[3] = $info[3]\n";
    for my $coord (@info) {
	my $coord_id = $id % 3;
	my $seg_id = int($id / 6);
	my $point_id = int($id / 3) % 2;
	# print "$id, [$seg_id][$point_id][$coord_id]\n";
	$segs[$seg_id][$point_id][$coord_id] = $coord;
	$id++;
    }
#     my($coord) = @_;
#     my $coord_id = $id % 3;
#     my $seg_id = int($id / 6);
#     my $point_id = int($id / 3) % 3;
#     $segs[$seg_id][$point_id][$coord_id] = $coord;
#     $id++;
}

sub gcf {
  my ($x, $y) = @_;
  ($x, $y) = ($y, $x % $y) while $y;
  return $x;
}

sub lcm {
  return($_[0] * $_[1] / gcf($_[0], $_[1]));
}

sub multigcf {
  my $x = shift;
  $x = gcf($x, shift) while @_;
  return $x;
}

sub multilcm {
  my $x = shift;
  $x = lcm($x, shift) while @_;
  return $x;
}


# die "Too few coordinates!" if ($id < 18);

# print "Segment 1: ($segs[0][0][0],$segs[0][0][1],$segs[0][0][2]),($segs[0][1][0],$segs[0][1][1],$segs[0][1][2])\n";
# print "Segment 2: ($segs[1][0][0],$segs[1][0][1],$segs[1][0][2]),($segs[1][1][0],$segs[1][1][1],$segs[1][1][2])\n";
# print "Segment 3: ($segs[2][0][0],$segs[2][0][1],$segs[2][0][2]),($segs[2][1][0],$segs[2][1][1],$segs[2][1][2])\n";

#d1 := {d1x, d1y, d1z}; d2 := {d2x, d2y, d2z}; d3 := {d3x, d3y, d3z};
#p1 := {p1x, p1y, p1z}; p2 := {p2x, p2y, p2z}; p3 := {p3x, p3y, p3z}

$p1x = $segs[0][0][0];
$p1y = $segs[0][0][1];
$p1z = $segs[0][0][2];

$p2x = $segs[1][0][0];
$p2y = $segs[1][0][1];
$p2z = $segs[1][0][2];

$p3x = $segs[2][0][0];
$p3y = $segs[2][0][1];
$p3z = $segs[2][0][2];

$d1x = $segs[0][1][0] - $segs[0][0][0];
$d1y = $segs[0][1][1] - $segs[0][0][1];
$d1z = $segs[0][1][2] - $segs[0][0][2];

$d2x = $segs[1][1][0] - $segs[1][0][0];
$d2y = $segs[1][1][1] - $segs[1][0][1];
$d2z = $segs[1][1][2] - $segs[1][0][2];

$d3x = $segs[2][1][0] - $segs[2][0][0];
$d3y = $segs[2][1][1] - $segs[2][0][1];
$d3z = $segs[2][1][2] - $segs[2][0][2];

$a = -$d3x * $d1y * $p2z + $d1x * $p2z * $d3y + $d1z * $d3x * $p2y -
      $d1z * $p2x * $d3y + $d1z * $p3x * $d3y - $d1z * $d3x * $p3y +
      $d3x * $d1y * $p3z - $d1x * $p3z * $d3y - $d1x * $d3z * $p2y +
      $d1x * $d3z * $p3y - $p3x * $d1y * $d3z + $p2x * $d1y * $d3z;

$b = $d3x * $p1z * $p2y - $d3x * $p2z * $p1y + $p1x * $d3y * $p2z -
     $p2x * $d3y * $p1z - $d3x * $p1z * $p3y + $d3x * $p2z * $p3y -
     $p3x * $p1y * $d3z + $p3x * $p2y * $d3z - $p3x * $d3y * $p2z +
     $p3x * $d3y * $p1z - $p2x * $d3z * $p3y + $p2x * $p1y * $d3z -
     $p1x * $d3z * $p2y + $p1x * $d3z * $p3y + $d3x * $p1y * $p3z -
     $d3x * $p2y * $p3z - $p1x * $p3z * $d3y + $p2x * $p3z * $d3y;

$c = -$d1x * $d2z * $d3y + $d3x * $d2z * $d1y + $d1x * $d2y * $d3z +
      $d2x * $d1z * $d3y - $d2x * $d3z * $d1y - $d3x * $d2y * $d1z;

$d = -$p3x * $d2y * $d3z - $d2x * $p3z * $d3y + $d2x * $p1z * $d3y +
     $p1x * $d2y * $d3z - $d3x * $d2z * $p3y - $d2x * $d3z * $p1y +
     $d2x * $d3z * $p3y - $d3x * $d2y * $p1z + $d3x * $d2y * $p3z +
     $p3x * $d2z * $d3y - $p1x * $d2z * $d3y + $d3x * $d2z * $p1y;

$common_factor = abs(multigcf($a, $b, $c, $d));
# print "common_factor = $common_factor\n";
$a = $a / $common_factor;
$b = $b / $common_factor;
$c = $c / $common_factor;
$d = $d / $common_factor;

# T2 = ($a * $T1 + $b)/($c * $T1 + $d)
my $t3_0 = eval_t3_0();
my $t3_1 = eval_t3_1();
my $t3_infinity = eval_t3_infinity();
print "$a $b $c $d $t3_0 $t3_1 $t3_infinity";

exit(0);

sub eval_t3_0 {
  my $a =
    $p1x * $d2y * $p3z - $p3x * $d2y * $p1z - $d2x * $p3z * $p1y +
    $d2x * $p1z * $p3y - $d2x * $p2y * $p1z + $d2x * $p2y * $p3z -
    $d2x * $p3y * $p2z - $p1x * $p2z * $d2y + $p2x * $p1z * $d2y -
    $p2x * $p3z * $d2y + $p3x * $p2z * $d2y + $p1x * $d2z * $p2y -
    $p1x * $d2z * $p3y + $p3x * $p1y * $d2z - $p3x * $d2z * $p2y -
    $p2x * $p1y * $d2z + $d2x * $p1y * $p2z + $p2x * $p3y * $d2z;

  my $b =
    -$d2x * $d1y * $p2z - $p3x * $d1y * $d2z + $p2x * $d1y * $d2z +
    $p3x * $d1z * $d2y - $p2x * $d1z * $d2y + $d2x * $d1z * $p2y +
    $d2x * $d1y * $p3z - $d2x * $d1z * $p3y + $d1x * $p2z * $d2y -
    $d1x * $p3z * $d2y + $d1x * $d2z * $p3y - $d1x * $d2z * $p2y;

    return $a / $b;
}

sub eval_t3_1 {
  my $a = 
- (-$p1x * $d2z * $d3y + $d3x * $d2z * $p1y + $p1x * $d2y * $d3z +
    $d2x * $p1z * $d3y - $d2x * $d3z * $p1y - $d3x * $d2y * $p1z +
    $p1x * $d2y * $p3z - $p3x * $d2y * $p1z - $d2x * $p3z * $p1y +
    $d2x * $p1z * $p3y + $d2x * $p1y * $p2z - $d2x * $p2y * $p1z +
    $d2x * $p2y * $p3z - $d2x * $p3y * $p2z - $p1x * $p2z * $d2y +
    $p2x * $p1z * $d2y - $p2x * $p3z * $d2y + $p3x * $p2z * $d2y +
    $p1x * $d2z * $p2y - $p1x * $d2z * $p3y + $p3x * $p1y * $d2z -
    $p3x * $d2z * $p2y - $p2x * $p1y * $d2z + $p2x * $p3y * $d2z -
    $d2x * $d3y * $p2z + $d2x * $p2y * $d3z - $d3x * $d2z * $p2y +
    $d3x * $p2z * $d2y - $p2x * $d3z * $d2y + $p2x * $d3y * $d2z);

  my $b =
    $d1x * $d2y * $d3z + $d2x * $d1z * $d3y - $d2x * $d3z * $d1y -
    $d3x * $d2y * $d1z - $d1x * $d2z * $d3y + $d3x * $d2z * $d1y +
    $d2x * $d1y * $p2z + $p3x * $d1y * $d2z - $p2x * $d1y * $d2z -
    $p3x * $d1z * $d2y + $p2x * $d1z * $d2y - $d2x * $d1z * $p2y -
    $d2x * $d1y * $p3z + $d2x * $d1z * $p3y - $d1x * $p2z * $d2y +
    $d1x * $p3z * $d2y - $d1x * $d2z * $p3y + $d1x * $d2z * $p2y;

  return $a / $b;
}

sub eval_t3_infinity {
  my $a = 
- (-$d2x * $d3z * $p1y + $p1x * $d2y * $d3z - $d3x * $d2y * $p1z +
    $d2x * $p1z * $d3y + $d2x * $p2y * $d3z - $d2x * $d3y * $p2z -
    $d3x * $d2z * $p2y + $d3x * $d2z * $p1y - $p1x * $d2z * $d3y +
    $d3x * $p2z * $d2y - $p2x * $d3z * $d2y + $p2x * $d3y * $d2z);

  my $b =
    $d1x * $d2y * $d3z + $d2x * $d1z * $d3y - $d2x * $d3z * $d1y -
    $d3x * $d2y * $d1z - $d1x * $d2z * $d3y + $d3x * $d2z * $d1y;

  return $a / $b;
}
